> For the complete documentation index, see [llms.txt](https://docs.geopard.tech/geopard-tutorials/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.geopard.tech/geopard-tutorials/jpn/apidokyumento/geopard-api-requests-overview/56.-upload-photos.md).

# 56. 写真をアップロード

S3経由で写真をアップロードする手順は2つあります。

1. **直接アップロードするための署名付きリンクをリクエストします。**

入力：

* fileExtention - jpeg、jpg、またはpng、
* farmUuid - 農場のUUID、
* fieldUuid - 圃場のUUID、
* noteUuid - アップロードした写真の直接リンクに対応するノートのUUID、
* commentUuid - アップロードした写真の直接リンクに対応するコメントのUUID（任意）。

出力：

* uuid - アップロードと処理の完了後に想定されるUUID、
* farmUuid - 入力値と同じ、
* fieldUuid - 入力値と同じ、
* noteUuid - 入力値と同じ、
* commentUuid - 入力値と同じ（指定されている場合）、
* s3Url - 写真のアップロードに使用するURL、
* s3Fields - 写真のアップロードフォームに渡す属性。

s3Urlとs3Fieldsの使用方法については、2つ目の手順で説明します。

写真をアップロードするための属性の有効期間は60分です。

{% code overflow="wrap" lineNumbers="true" %}

```graphql
mutation generatePresignedPostPhotoData {
  generatePresignedPostPhotoData(input:{
    farmUuid: "89196056-61e5-4bce-b676-d488d611a829" 
    fieldUuid: "586a2ef2-03e4-4715-846c-07a2f0cb3016"
    noteUuid: "4a94da1c-f655-4f17-961a-4b0323e5129c"
    fileExtention: jpeg
    
  } ) {
    uuid
    noteUuid
    fieldUuid
    farmUuid
    s3Url
    s3Fields
  }
}
```

{% endcode %}

2. **s3Fieldsで指定されたフォーム属性を使って、ローカルの写真をs3Urlに送信します。**

{% code overflow="wrap" lineNumbers="true" %}

```bash
curl --location --request POST '<s3Url>' \
--form 'key="<value_in_s3Fields>"' \
--form 'AWSAccessKeyId="<value_in_s3Fields>"' \
--form 'x-amz-security-token="<value_in_s3Fields>"' \
--form 'policy="<value_in_s3Fields>"' \
--form 'signature="<value_in_s3Fields>"' \
--form 'file=@"<local_file_path>"'
```

{% endcode %}

処理に関する通知は、GraphQL -> Samples -> で説明されているサブスクリプションの仕組みを通じて配信されます。 [1. サブスクリプション：イベントを取得する](https://docs.geopard.tech/geopard-tutorials/jpn/apidokyumento/geopard-api-requests-overview/1.-subscription-get-events.md).

{% hint style="info" %}
‘Accept-Encoding’:’gzip, deflate, br’ を使用します。
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.geopard.tech/geopard-tutorials/jpn/apidokyumento/geopard-api-requests-overview/56.-upload-photos.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
